/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.EntCosmos;

import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author obper
 */
@Entity
@Table(name = "detalle_compra")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "DetalleCompra.findAll", query = "SELECT d FROM DetalleCompra d"),
        @NamedQuery(name = "DetalleCompra.findByCompraCodigo", query = "SELECT d FROM DetalleCompra d WHERE d.detalleCompraPK.compraCodigo = :compraCodigo"),
        @NamedQuery(name = "DetalleCompra.findByProductoCodigo", query = "SELECT d FROM DetalleCompra d WHERE d.detalleCompraPK.productoCodigo = :productoCodigo"),
        @NamedQuery(name = "DetalleCompra.findByCantidad", query = "SELECT d FROM DetalleCompra d WHERE d.cantidad = :cantidad"),
        @NamedQuery(name = "DetalleCompra.findByCompraPrecio", query = "SELECT d FROM DetalleCompra d WHERE d.compraPrecio = :compraPrecio"),
        @NamedQuery(name = "DetalleCompra.findByTipo", query = "SELECT d FROM DetalleCompra d WHERE d.detalleCompraPK.tipo = :tipo"),
        @NamedQuery(name = "DetalleCompra.findByDetalleEnvio", query = "SELECT d FROM DetalleCompra d WHERE d.detalleEnvio = :detalleEnvio")})
public class DetalleCompra implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected DetalleCompraPK detalleCompraPK;
    @Basic(optional = false)
    @NotNull
    @Column(name = "cantidad")
    private int cantidad;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Basic(optional = false)
    @NotNull
    @Column(name = "compra_precio")
    private BigDecimal compraPrecio;
    @Basic(optional = false)
    @NotNull
    @Column(name = "detalle_envio")
    private Character detalleEnvio;
    @JoinColumn(name = "compra_codigo", referencedColumnName = "compra_codigo", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Compras compras;

    public DetalleCompra() {
    }

    public DetalleCompra(DetalleCompraPK detalleCompraPK) {
        this.detalleCompraPK = detalleCompraPK;
    }

    public DetalleCompra(DetalleCompraPK detalleCompraPK, int cantidad, BigDecimal compraPrecio, Character detalleEnvio) {
        this.detalleCompraPK = detalleCompraPK;
        this.cantidad = cantidad;
        this.compraPrecio = compraPrecio;
        this.detalleEnvio = detalleEnvio;
    }

    public DetalleCompra(String compraCodigo, String productoCodigo, String tipo) {
        this.detalleCompraPK = new DetalleCompraPK(compraCodigo, productoCodigo, tipo);
    }

    public DetalleCompraPK getDetalleCompraPK() {
        return detalleCompraPK;
    }

    public void setDetalleCompraPK(DetalleCompraPK detalleCompraPK) {
        this.detalleCompraPK = detalleCompraPK;
    }

    public int getCantidad() {
        return cantidad;
    }

    public void setCantidad(int cantidad) {
        this.cantidad = cantidad;
    }

    public BigDecimal getCompraPrecio() {
        return compraPrecio;
    }

    public void setCompraPrecio(BigDecimal compraPrecio) {
        this.compraPrecio = compraPrecio;
    }

    public Character getDetalleEnvio() {
        return detalleEnvio;
    }

    public void setDetalleEnvio(Character detalleEnvio) {
        this.detalleEnvio = detalleEnvio;
    }

    public Compras getCompras() {
        return compras;
    }

    public void setCompras(Compras compras) {
        this.compras = compras;
    }

//    @Override
//    public int hashCode() {
//        int hash = 0;
//        hash += (detalleCompraPK != null ? detalleCompraPK.hashCode() : 0);
//        return hash;
//    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DetalleCompra)) {
            return false;
        }
        DetalleCompra other = (DetalleCompra) object;
        if ((this.detalleCompraPK == null && other.detalleCompraPK != null) || (this.detalleCompraPK != null && !this.detalleCompraPK.equals(other.detalleCompraPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.cosmodas.dbcon.DetalleCompra[ detalleCompraPK=" + detalleCompraPK + " ]";
    }

}
